/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of IO.xs. Do not edit this file, edit IO.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "IO.xs"
// CVS: $Id: IO.xs,v 1.5 2002/04/18 09:19:59 michael Exp $
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <sys/signal.h>




typedef int BOOL;
#define FALSE 0
#define TRUE 1
#define BUFLEN 255

#define SOH 0x01
#define STX 0x02
#define ETX 0x03
#define EOT 0x04
#define ENQ 0x05
#define ACK 0x06
#define DLE 0x10
#define DC2 0x12
#define DC3 0x13
#define NAK 0x15

/* command: <SOH> <char> <checksum> <EOT> */
static char *command[] = {
	"\x01\x30\xcf\x04",	/* '0' = Poll DCF time */
	"\x01\x31\xce\x04",	/* '1' = Request dataset */
	"\x01\x32\xcd\x04",	/* '2' = Select next dataset */
	"\x01\x33\xcc\x04",	/* '3' = Activate 9 temperature sensors */
	"\x01\x34\xcb\x04",	/* '4' = Activate 16 temperature sensors */
	"\x01\x35\xca\x04",	/* '5' = Request status */
	"\x01\x36\x53\xc9\x04",	/* '6' = Set interval time */
};



static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int len, int arg)
{
    errno = EINVAL;
    return 0;
}

volatile int wait_flag = TRUE;	/* TRUE while no signal received */
volatile int alarm_flag = FALSE;	/* FALSE while timer running */
struct termios optionsold;	/* old serial port settings */


/* handles SIGIO */
void signal_handler_IO(int signum)
{
	wait_flag = FALSE;	/* serial input available */
}

/* handles SIGALRM */
void signal_handler_alarm(int signum)
{
	alarm_flag = TRUE;	/* serial input timed out */
}



/* opens serial port */
int open_port(char *serial_port)
{
	int fd;
	char serial_device[BUFLEN];
	struct termios options;

	/* open serial port */
	sprintf(serial_device, "/dev/%s", serial_port);
	fd = open(serial_device,
		  O_RDWR | O_NONBLOCK | O_NOCTTY | O_NDELAY);
	if (fd == -1) {
              printf("Error : could not open port %s.\n", serial_device);
		return fd;
	}

	/* install signal handlers */
	if (signal(SIGIO, signal_handler_IO) == SIG_ERR) {
              printf("Error : no SIGIO handler installed.\n");

		return -1;
	}
	if (signal(SIGALRM, signal_handler_alarm) == SIG_ERR) {
              printf("Error : no SIGALRM handler installed.\n");

		return -1;
	}

	/* remember old serial options */
	tcgetattr(fd, &optionsold);
	tcgetattr(fd, &options);

	/* allow this process to receive SIGIO and make fd asynchronous */
	fcntl(fd, F_SETOWN, getpid());
	fcntl(fd, F_SETFL, FASYNC);

	/* set 9600 baud speed */
	cfsetispeed(&options, B9600);
	cfsetospeed(&options, B9600);

	/* set 8n1 + extra stopbit */
	options.c_cflag = PARENB | CLOCAL | CREAD | CS8 | CSTOPB;
	options.c_oflag = 0;

	/* ignore parity errors */
	options.c_iflag = BRKINT | IGNPAR;
	options.c_lflag = PENDIN;

	/* abort reads after 0.1 sec */
	options.c_cc[VMIN] = 0;
	options.c_cc[VTIME] = 1;

	/* set new serial options */
	tcflush(fd, TCIFLUSH);
	tcsetattr(fd, TCSANOW, &options);

	return fd;
}

/* closes serial port */
void close_port(int fd)
{
	tcsetattr(fd, TCSAFLUSH, &optionsold);
	close(fd);
}




void set_dtr(int fd)
{
	int temp;

	ioctl(fd, TIOCMGET, &temp);
	temp |= TIOCM_DTR;
	ioctl(fd, TIOCMSET, &temp);
}

/* lowers DTR */
void clr_dtr(int fd)
{
	int temp;

	ioctl(fd, TIOCMGET, &temp);
	temp &= ~TIOCM_DTR;
	ioctl(fd, TIOCMSET, &temp);
}

int send_command(int fd, char cmd, unsigned char par)
{
	int res,idx;
	
	idx = cmd - 0x30;
	if (idx == 6) {
		/* use temporary string, otherwise segmentation fault */
		char com[5];
		strncpy(com, command[idx], 5);
		com[2] = par;
		com[3] = 255 - (com[1] + com[2]);
		res = write(fd, com, 5);
	} else
		res = write(fd, command[idx], 4);

	if (res == -1)
              printf("Error in serial output.\n");
	return res;
}



#line 197 "IO.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 341 "IO.c"

XS_EUPXS(XS_Device__WS2000__IO_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, arg");
    {
#line 193 "IO.xs"
	STRLEN		len;
#line 352 "IO.c"
	SV *	sv = ST(0)
;
	char *	s = SvPV(sv, len);
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;
#line 199 "IO.xs"
	RETVAL = constant(s,len,arg);
#line 362 "IO.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__WS2000__IO_set_dtr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_set_dtr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
#line 206 "IO.xs"
	set_dtr(fd);
#line 381 "IO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__WS2000__IO_clr_dtr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_clr_dtr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
#line 211 "IO.xs"
	clr_dtr(fd);
#line 398 "IO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__WS2000__IO_open_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_open_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "port");
    {
	int	RETVAL;
	dXSTARG;
	char *	port = (char *)SvPV_nolen(ST(0))
;
#line 216 "IO.xs"
	RETVAL=open_port(port);
#line 417 "IO.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Device__WS2000__IO_close_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_close_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
#line 223 "IO.xs"
	close_port(fd);
#line 436 "IO.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Device__WS2000__IO_send_command); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Device__WS2000__IO_send_command)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, cmd, par");
    {
	int	RETVAL;
	dXSTARG;
	int	fd = (int)SvIV(ST(0))
;
	char	cmd = (char)*SvPV_nolen(ST(1))
;
	unsigned char	par = (unsigned char)SvUV(ST(2))
;
#line 228 "IO.xs"
	RETVAL=send_command(fd,cmd,par);
#line 459 "IO.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Device__WS2000__IO); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Device__WS2000__IO)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Device::WS2000::IO::constant", XS_Device__WS2000__IO_constant);
        newXS_deffile("Device::WS2000::IO::set_dtr", XS_Device__WS2000__IO_set_dtr);
        newXS_deffile("Device::WS2000::IO::clr_dtr", XS_Device__WS2000__IO_clr_dtr);
        newXS_deffile("Device::WS2000::IO::open_port", XS_Device__WS2000__IO_open_port);
        newXS_deffile("Device::WS2000::IO::close_port", XS_Device__WS2000__IO_close_port);
        newXS_deffile("Device::WS2000::IO::send_command", XS_Device__WS2000__IO_send_command);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
